/*
 * input/output for any type of vector, matrix, tensor < vmtio.c >
 *
 * VMT: Vector Matrix Tensor I/O
 *
 * Copyright (C) 1999 Taiji Yamada
 */
#ifndef _VMTIO_H_
#define _VMTIO_H_
#include <stdio.h>

typedef enum fcctype {
  FCCTYPE_VOID,
  FCCTYPE_CHAR,
  FCCTYPE_WCHAR,
  FCCTYPE_STRING,
  FCCTYPE_WSTRING,
  FCCTYPE_INT,
  FCCTYPE_SHORT,
  FCCTYPE_LONG,
  FCCTYPE_UINT,
  FCCTYPE_USHORT,
  FCCTYPE_ULONG,
  FCCTYPE_FLOAT,
  FCCTYPE_DOUBLE,
  FCCTYPE_QUADRUPLE,
} fcctype_t;

fcctype_t fccode_type(char *f);

size_t fccode_size(char *f);

int (vector_fprintf)(size_t size, FILE *fp, char *f, void *v, long nl, long nh);

#define vector_fprintf(type, fp, f, v, nl, nh) (vector_fprintf)(sizeof(type), fp, f, (void *)v, nl, nh)

int (vector_sprintf)(size_t size, char *buf, char *f, void *v, long nl, long nh);

#define vector_sprintf(type, buf, f, v, nl, nh) (vector_sprintf)(sizeof(type), buf, f, (void *)v, nl, nh)

int (vector_printf)(size_t size, char *f, void *v, long nl, long nh);

#define vector_printf(type, f, v, nl, nh) (vector_printf)(sizeof(type), f, (void *)v, nl, nh)

int (vector_sscanf)(size_t size, char *buf, char *f, void **v, long nl, long *nh);

#define vector_sscanf(type, buf, f, v, nl, nh) vector_sscanf(sizeof(type), buf, f, (void **)v, nl, nh)

#if 0 /* UNCOMPLETED */
int (vector_fscanf)(size_t size, FILE *fp, char *f, void **v, long nl, long *nh);

#define vector_fscanf(type, fp, f, v, nl, nh) (vector_fscanf)(sizeof(type), fp, f, (void **)v, nl, nh) 

int (vector_scanf)(size_t size, char *f, void **v, long nl, long *nh);

#define vector_scanf(type, f, v, nl, nh) (vector_scanf)(sizeof(type), f, (void **)v, nl, nh) 
#endif

int (matrix_fprintf)(size_t size, FILE *fp, char *f, void **m, long nrl, long nrh, long ncl, long nch);

#define matrix_fprintf(type, fp, f, m, nrl, nrh, ncl, nch) (matrix_fprintf)(sizeof(type), fp, f, (void **)m, nrl, nrh, ncl, nch)

int (matrix_sprintf)(size_t size, char *buf, char *f, void **m, long nrl, long nrh, long ncl, long nch);

#define matrix_sprintf(type, buf, f, m, nrl, nrh, ncl, nch) (matrix_sprintf)(sizeof(type), buf, f, (void **)m, nrl, nrh, ncl, nch)

int (matrix_printf)(size_t size, char *f, void **m, long nrl, long nrh, long ncl, long nch);

#define matrix_printf(type, f, m, nrl, nrh, ncl, nch) (matrix_printf)(sizeof(type), f, (void **)m, nrl, nrh, ncl, nch)

int (matrix_sscanf)(size_t size, char *buf, char *f, void ***m, long nrl, long *nrh, long ncl, long *nch);

#define matrix_sscanf(type, buf, f, m, nrl, nrh, ncl, nch) matrix_sscanf(sizeof(type), buf, f, (void ***)m, nrl, nrh, ncl, nch)

#if 0 /* UNCOMPLETED */
int (matrix_fscanf)(size_t size, FILE *fp, char *f, void ***m, long nrl, long *nrh, long ncl, long *nch);

#define matrix_fscanf(type, fp, f, m, nrl, nrh, ncl, nch) (matrix_fscanf)(sizeof(type), fp, f, m, nrl, nrh, ncl, nch)

int (matrix_scanf)(size_t size, char *f, void ***m, long nrl, long *nrh, long ncl, long *nch);

#define matrix_scanf(type, f, m, nrl, nrh, ncl, nch) (matrix_scanf)(sizeof(type), f, m, nrl, nrh, ncl, nch)
#endif

int (matrixT_fprintf)(size_t size, FILE *fp, char *f, void **m, long nrl, long nrh, long ncl, long nch);

#define matrixT_fprintf(type, fp, f, m, nrl, nrh, ncl, nch) (matrixT_fprintf)(sizeof(type), fp, f, (void **)m, nrl, nrh, ncl, nch)

int (matrixT_sprintf)(size_t size, char *buf, char *f, void **m, long nrl, long nrh, long ncl, long nch);

#define matrixT_sprintf(type, buf, f, m, nrl, nrh, ncl, nch) (matrixT_sprintf)(sizeof(type), buf, f, (void **)m, nrl, nrh, ncl, nch)

int (matrixT_printf)(size_t size, char *f, void **m, long nrl, long nrh, long ncl, long nch);

#define matrixT_printf(type, f, m, nrl, nrh, ncl, nch) (matrixT_printf)(sizeof(type), f, (void **)m, nrl, nrh, ncl, nch)

int (matrixT_sscanf)(size_t size, char *buf, char *f, void ***m, long ncl, long *nch, long nrl, long *nrh/*long nrl, long *nrh, long ncl, long *nch*/);

#define matrixT_sscanf(type, buf, f, m, ncl, nch, nrl, nrh) (matrixT_sscanf)(sizeof(type), buf, f, (void ***)m, ncl, nch, nrl, nrh) 

#if 0 /* UNCOMPLETED */
int (matrixT_fscanf)(size_t size, FILE *fp, char *f, void ***m, long ncl, long *nch, long nrl, long *nrh/*long nrl, long *nrh, long ncl, long *nch*/);

#define matrixT_fscanf(type, fp, f, m, ncl, nch, nrl, nrh) (matrixT_fscanf)(sizeof(type), fp, f, m, ncl, nch, nrl, nrh)

int (matrixT_scanf)(size_t size, char *f, void ***m, long ncl, long *nch, long nrl, long *nrh/*long nrl, long *nrh, long ncl, long *nch*/);

#define matrixT_scanf(type, f, m, ncl, nch, nrl, nrh) (matrixT_scanf)(sizeof(type), f, m, ncl, nch, nrl, nrh)
#endif

int (f3tensor_fprintf)(size_t size, FILE *fp, char *f, void ***t, long nrl, long nrh, long ncl, long nch, long ndl, long ndh);

#define f3tensor_fprintf(type, fp, f, t, nrl, nrh, ncl, nch, ndl, ndh) (f3tensor_fprintf)(sizeof(type), fp, f, (void ***)t, nrl, nrh, ncl, nch, ndl, ndh)

int (f3tensor_sprintf)(size_t size, char *buf, char *f, void ***t, long nrl, long nrh, long ncl, long nch, long ndl, long ndh);

#define f3tensor_sprintf(type, buf, f, t, nrl, nrh, ncl, nch, ndl, ndh) (f3tensor_sprintf)(sizeof(type), buf, f, (void ***)t, nrl, nrh, ncl, nch, ndl, ndh)

int (f3tensor_printf)(size_t size, char *f, void ***t, long nrl, long nrh, long ncl, long nch, long ndl, long ndh);

#define f3tensor_printf(type, f, t, nrl, nrh, ncl, nch, ndl, ndh) (f3tensor_printf)(sizeof(type), f, (void ***)t, nrl, nrh, ncl, nch, ndl, ndh)

int (f3tensor_sscanf)(size_t size, char *buf, char *f, void ****t, long nrl, long *nrh, long ncl, long *nch, long ndl, long *ndh);

#define f3tensor_sscanf(type, buf, f, t, nrl, nrh, ncl, nch, ndl, ndh) (f3tensor_sscanf)(sizeof(type), buf, f, (void ****)t, nrl, nrh, ncl, nch, ndl, ndh)

#if 0 /* UNCOMPLETED */
int (f3tensor_fscanf)(size_t size, FILE *fp, char *f, void ****t, long nrl, long *nrh, long ncl, long *nch, long ndl, long *ndh);

#define f3tensor_fscanf(type, fp, f, t, nrl, nrh, ncl, nch, ndl, ndh) (f3tensor_fscanf)(sizeof(type), fp, f, t, nrl, nrh, ncl, nch, ndl, ndh)

int (f3tensor_scanf)(size_t size, char *f, void ****t, long nrl, long *nrh, long ncl, long *nch, long ndl, long *ndh);

#define f3tensor_scanf(type, f, t, nrl, nrh, ncl, nch, ndl, ndh) (f3tensor_scanf)(sizeof(type), f, t, nrl, nrh, ncl, nch, ndl, ndh)
#endif

#endif /* _VMTIO_H_ */
