/*
 * memory allocator for any type of vector, matrix, tensor < vmtlib.h >
 *
 * VMT: Vector Matrix Tensor lib, Numerial Recipes in C compatible
 *
 * Copyright (C) 1999 Taiji Yamada
 */
#ifndef _VMTLIB_H_
#define _VMTLIB_H_

void *(vector_alloc)(size_t size, long nl, long nh);

void (vector_free)(size_t size, void *v, long nl);

void **(matrix_alloc)(size_t size, long nrl, long nrh, long ncl, long nch);

void (matrix_free)(size_t size, void **m, long nrl, long ncl);

void ***(f3tensor_alloc)(size_t size, long nrl, long nrh, long ncl, long nch, long ndl, long ndh);

void (f3tensor_free)(size_t size, void ***t, long nrl, long ncl, long ndl);

#define vector_alloc(type, nl, nh) (type *)(vector_alloc)(sizeof(type), nl, nh)

#define vector_free(type, v, nl, nh) (vector_free)(sizeof(type), (void *)v, nl)

#define matrix_alloc(type, ncl, nch, nrl, nrh) (type **)(matrix_alloc)(sizeof(type), ncl, nch, nrl, nrh)

#define matrix_free(type, m, nrl, nrh, ncl, nch) (matrix_free)(sizeof(type), (void **)m, nrl, ncl)

#define f3tensor_alloc(type, ncl, nch, nrl, nrh, ndl, ndh) (type ***)(f3tensor_alloc)(sizeof(type), ncl, nch, nrl, nrh, ndl, ndh)

#define f3tensor_free(type, t, ncl, nch, nrl, nrh, ndl, ndh) (f3tensor_free)(sizeof(type), (void ***)t, ncl, nrl, ndl)

#endif /* _VMTLIB_H_ */
