/*
 * test for vmtlib.h
 *
 * Copyright (C) 1999 Taiji Yamada <taiji@aihara.co.jp>
 */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "vmtio.h"
#include "vmtlib.h"

#define v_l 0
#define v_h 19

#define m_rl 1
#define m_rh 5
#define m_cl 1
#define m_ch 5

#define t_rl 0
#define t_rh 2
#define t_cl 1
#define t_ch 5
#define t_dl 1
#define t_dh 10

void main()
{
  int i, j, k;
  {
    int *v, **m, ***t;

    v = vector_alloc(int, v_l,v_h);
    m = matrix_alloc(int, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(int, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(int, "%03d", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(int, "%03d", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(int, "%03d", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(int, "%03d", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(int, v, v_l,v_h);
    matrix_free(int, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(int, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
  {
    short *v, **m, ***t;

    v = vector_alloc(short, v_l,v_h);
    m = matrix_alloc(short, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(short, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(short, "%03hd", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(short, "%03hd", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(short, "%03hd", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(short, "%03hd", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(short, v, v_l,v_h);
    matrix_free(short, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(short, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
  {
    long *v, **m, ***t;

    v = vector_alloc(long, v_l,v_h);
    m = matrix_alloc(long, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(long, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(long, "%03ld", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(long, "%03ld", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(long, "%03ld", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(long, "%03ld", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(long, v, v_l,v_h);
    matrix_free(long, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(long, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
  {
    unsigned int *v, **m, ***t;

    v = vector_alloc(unsigned int, v_l,v_h);
    m = matrix_alloc(unsigned int, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(unsigned int, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(unsigned int, "%03u", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(unsigned int, "%03u", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(unsigned int, "%03u", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(unsigned int, "%03u", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(unsigned int, v, v_l,v_h);
    matrix_free(unsigned int, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(unsigned int, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
  {
    unsigned short *v, **m, ***t;

    v = vector_alloc(unsigned short, v_l,v_h);
    m = matrix_alloc(unsigned short, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(unsigned short, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(unsigned short, "%03hu", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(unsigned short, "%03hu", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(unsigned short, "%03hu", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(unsigned short, "%03hu", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(unsigned short, v, v_l,v_h);
    matrix_free(unsigned short, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(unsigned short, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
  {
    unsigned long *v, **m, ***t;

    v = vector_alloc(unsigned long, v_l,v_h);
    m = matrix_alloc(unsigned long, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(unsigned long, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(unsigned long, "%03lu", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(unsigned long, "%03lu", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(unsigned long, "%03lu", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(unsigned long, "%03lu", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(unsigned long, v, v_l,v_h);
    matrix_free(unsigned long, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(unsigned long, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
  {
    float *v, **m, ***t;

    v = vector_alloc(float, v_l,v_h);
    m = matrix_alloc(float, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(float, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(float, "%03g", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(float, "%03g", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(float, "%03g", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(float, "%03g", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(float, v, v_l,v_h);
    matrix_free(float, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(float, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
  {
    double *v, **m, ***t;

    v = vector_alloc(double, v_l,v_h);
    m = matrix_alloc(double, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(double, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(double, "%03g", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(double, "%03g", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(double, "%03g", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(double, "%03g", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(double, v, v_l,v_h);
    matrix_free(double, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(double, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
  {
    long double *v, **m, ***t;

    v = vector_alloc(long double, v_l,v_h);
    m = matrix_alloc(long double, m_rl,m_rh, m_cl,m_ch);
    t = f3tensor_alloc(long double, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);

    for (i=v_l; i<=v_h; i++)
      v[i] = i-v_l;
    for (i=m_rl; i<=m_rh; i++)
      for (j=m_cl; j<=m_ch; j++)
	m[i][j] = (i-m_rl)*(m_ch-m_cl+1)+(j-m_cl);
    for (i=t_rl; i<=t_rh; i++)
      for (j=t_cl; j<=t_ch; j++)
	for (k=t_dl; k<=t_dh; k++)
	  t[i][j][k] = (i-t_rl)*(t_dh-t_dl+1)*(t_ch-t_cl+1)+(j-t_cl)*(t_dh-t_dl+1)+(k-t_dl);

    printf("# v:\n");
    vector_printf(long double, "%03Lg", v, v_l,v_h);
    printf("\n");
    printf("# m:\n");
    matrix_printf(long double, "%03Lg", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# m^T:\n");
    matrixT_printf(long double, "%03Lg", m, m_rl,m_rh, m_cl,m_ch);
    printf("\n");
    printf("# t:\n");
    f3tensor_printf(long double, "%03Lg", t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
    printf("\n");

    vector_free(long double, v, v_l,v_h);
    matrix_free(long double, m, m_rl,m_rh, m_cl,m_ch);
    f3tensor_free(long double, t, t_rl,t_rh, t_cl,t_ch, t_dl,t_dh);
  }
}
